using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Weigelt.Windows.Forms;
using System.Diagnostics;

namespace EventFilterDemo
{
	/// <summary>
	/// Main form of the demo application
	/// </summary>
	public partial class MainForm : Form
	{
		private int m_nOriginalEventCount = -1;
		private int m_nFilteredEventCount = -1;

		private EventFilter<EventArgs> m_objSelectedIndexChangedEventFilter = new EventFilter<EventArgs>();

		#region ... Misc helper methods ...

		private void UpdateOriginalEventCounter()
		{
			c_lblOriginalEventCountValue.Text = m_nOriginalEventCount.ToString();
		}

		private void UpdateFilteredEventCounter()
		{
			c_lblFilteredEventCountValue.Text = m_nFilteredEventCount.ToString();
		}

		private void c_lnkResetCounters_LinkClicked( object sender, LinkLabelLinkClickedEventArgs e )
		{
			m_nFilteredEventCount = 0;
			m_nOriginalEventCount = 0;
			UpdateOriginalEventCounter();
			UpdateFilteredEventCounter();
		}
		#endregion

		private void c_lsbEventSource_Filtered_SelectedIndexChanged( object sender, EventArgs e )
		{
			++m_nFilteredEventCount;
			UpdateFilteredEventCounter();
		}

		/// <summary>
		/// Initializes a new instance of the &lt;see cref="MainForm" /&gt; class.
		/// </summary>
		public MainForm()
		{
			InitializeComponent();

			#region ... Just for demo purposes ...
			c_lsbEventSource.SelectedIndexChanged += delegate( object sender, EventArgs e )
			{
				++m_nOriginalEventCount;
				UpdateOriginalEventCounter();
			};
			#endregion

			c_lsbEventSource.SelectedIndexChanged += m_objSelectedIndexChangedEventFilter.HandleOriginalEvent;
			m_objSelectedIndexChangedEventFilter.FilteredEventRaised += c_lsbEventSource_Filtered_SelectedIndexChanged;

			c_lsbEventSource.SelectedIndex = 0;
		}

	}
}